<template>
  <div
    class="col col-grow"
  >
    <div>
      <q-table
        :columns="computedColumns"
        :data="users"
        dense
        :rows-per-page-options="[5, 10, 15, 20, 25, 50, 100]"
        :pagination.sync="pagination"
        class="bg-white"
      >
        <q-tr
          slot="header"
          slot-scope="props"
          :props="props"
        >
          <th
            v-for="col in props.cols"
            :key="col.name"
            class="sortable vertical-bottom"
            :class="{
                sorted: pagination.sortBy === col.name,
                'sort-desc': pagination.sortBy === col.name && pagination.descending,
                'bg-red-2': ((col.name in timestampColumns && !timestampColumns[col.name][0]) || !(col.name in timestampColumns)) && attachedColumns[col.name] === null
              }"
          >
            <div
              class="flex items-center no-wrap q-pt-xs"
              @click="sortBy(col.name)"
            >
              <div>
                <div>
                  <span>{{ col.label }}</span>
                  <span
                    v-if="availableRequiredColumns.indexOf(col.name) > -1"
                    class="text-red"
                  >*</span>
                </div>
              </div>
              <q-icon
                name="arrow_upward"
                class="q-table-sort-icon q-table-sort-icon-right"
              />
            </div>
            <div
              v-if="col.name in computedAvailableColumnsRules"
              class="text-grey text-left text-italic"
            >
              <span>{{computedAvailableColumnsRules[col.name]}}</span>
            </div>
            <div
              v-if="col.name in timestampColumns"
              class="q-mt-xs text-left"
            >
              <q-checkbox
                label="Is timestamp"
                v-model="timestampColumns[col.name][0]"
              />
              <q-chips-input
                v-if="timestampColumns[col.name][0]"
                v-model="timestampColumnsCameras[col.name]"
                dense
                stack-label="Cameras"
                class="q-mt-xs"
              >
                <q-autocomplete
                  @search="(terms, done) => searchCameras(col.name, terms, done)"
                />
              </q-chips-input>
            </div>
            <q-select
              v-if="!(col.name in timestampColumns) || !timestampColumns[col.name][0]"
              v-model="attachedColumns[col.name]"
              :options="getAvailableColumnsOptions(col.name)"
              :disable="defaultAttachedColumns.indexOf(col.name) > -1"
              dense
              filter
              @change="$forceUpdate()"
              placeholder="Choose..."
              class="q-mt-md"
              clearable
            />
          </th>
        </q-tr>
        <q-tr
          slot="body"
          slot-scope="props"
          :props="props"
          @dblclick.native="clickRow(props.row.__index)"
        >
          <q-td
            v-for="column in computedColumns"
            :key="column.name"
            :class="{
                'bg-green-1':
                  (column.field in timestampColumns)
                  && timestampColumns[column.field][0]
                  && timestampColumns[column.field][2](props.row[column.field]),
                'bg-red-1':
                  (column.field in timestampColumns)
                  && timestampColumns[column.field][0]
                  && !timestampColumns[column.field][2](props.row[column.field])
              }"
          >
            {{props.row[column.field]}}
          </q-td>
        </q-tr>
      </q-table>
    </div>
  </div>
</template>

<script>
    import apiMixin from '../../mixins/apiMixin';

    export default {
      name: 'compare-table',
      mixins: [apiMixin],
      props: {
        users: Array,
        timestampColumns: Object,
        attachedColumns: Object,
        defaultAttachedColumns: Array,
        timestampColumnsCameras: Object,
        availableColumns: Array,
        columns: Array,
      },
      created() {
        this.getCameras();
      },
      data() {
        return {
          pagination: {
            rowsPerPage: 10,
          },
          availableRequiredColumns: [
            'email',
            'concurrent_no',
            'race_id',
            'timestamp',
            'camera_id',
          ],
          availableColumnsRules: {
            date_of_birth: 'formatted in "dd.MM.yyyy"',
            race_finish_timing: 'unix timestamp in milliseconds',
          },

          availableCameras: [],
        };
      },
      computed: {
        computedColumnsKeys() {
          return this.columns;
        },
        computedColumns() {
          return this.computedColumnsKeys
            .map((key) => ({
              name: key,
              label: this.getColumnLabel(key),
              field: key,
              align: 'left',
              sortable: true,
            }));
        },
        computedAvailableColumnsRules() {
          const columns = {};
          const rules = {};

          Object.entries(this.attachedColumns).forEach(([key, column]) => {
            columns[column] = key;
          });

          Object.entries(this.availableColumnsRules).forEach(([key, rule]) => {
            if (key in columns) {
              rules[columns[key]] = rule;
            }
          });

          return rules;
        },
      },
      watch: {
        attachedColumns: {
          deep: true,
          handler() {
            this.$eventHub.$emit('timingSchemaChanged');
          },
        },
        timestampColumns: {
          deep: true,
          handler() {
            this.$eventHub.$emit('timingSchemaChanged');
          },
        },
        timestampColumnsCameras: {
          deep: true,
          handler() {
            this.$eventHub.$emit('timingSchemaChanged');
          },
        },
        // eslint-disable-next-line func-names
        '$store.state.location.location.id': function () {
          this.$nextTick(() => {
            this.getCameras();
          });
        },
      },
      methods: {
        clickRow(index) {
          this.$eventHub.$emit('compareUserClicked', index);
        },
        getColumnLabel(label) {
          return label.split('_').map((item) => item[0].toUpperCase() + item.toLowerCase().slice(1)).join(' ');
        },
        sortBy(field) {
          if (this.pagination.sortBy === field && this.pagination.descending) {
            this.pagination.sortBy = null;
            this.pagination.descending = false;
          } else {
            this.pagination.descending = this.pagination.sortBy === field;
            this.pagination.sortBy = field;
          }
        },
        getAvailableColumnsOptions(val) {
          return [
            ...(this.attachedColumns[val] ? [
              this.attachedColumns[val],
            ] : []),
            ...(
              this.availableColumns
                .filter((value) => (
                  Object.values(this.attachedColumns).indexOf(value) === -1
                ))
            ),
          ]
            .filter((value, index, self) => self.indexOf(value) === index)
            .map((value) => ({
              value,
              label: value,
            }));
        },
        searchCameras(column, terms, done) {
          done(
            this.availableCameras.filter(
              ({
                 label,
                 value,
               }) => this.timestampColumnsCameras[column].indexOf(value) === -1 && label.indexOf(terms) > -1,
            ),
          );
        },
        getCameras() {
          this.apiGet('rest-sql/cameras/list', {
            params: {
              location_id: this.$store.state.location.location.id,
            },
          })
            .then(({ results }) => {
              const availableCameras = [];
              results.forEach(({ cam_tag: camTag, cam_id: camId }) => {
                const id = `[${ camId }]${ camTag ? ` ${ camTag }` : '' }`;
                availableCameras.push({
                  value: camId,
                  label: String(id),
                });
              });
              this.availableCameras = availableCameras;
            });
        },
      },
    };
</script>
